#  Copyright (C) 2014, 2015, 2018  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require_relative 'twb/tabclass'
require_relative 'twb/tabtool'
require_relative 'twb/dashboard'
require_relative 'twb/datasource'
require_relative 'twb/connection'
require_relative 'twb/docdashboard'
require_relative 'twb/dbfield'
require_relative 'twb/localfield'
require_relative 'twb/metadatafield'
require_relative 'twb/storyboard'
require_relative 'twb/window'
require_relative 'twb/workbook'
require_relative 'twb/worksheet'
require_relative 'twb/parameter'
require_relative 'twb/action'
require_relative 'twb/columnfield.rb'
require_relative 'twb/calculatedfield'
require_relative 'twb/codedfield'
require_relative 'twb/groupfield'
require_relative 'twb/fieldcalculation'
require_relative 'twb/quickfilter'
# require_relative 'twb/docdashboardimagevert'
# require_relative 'twb/docdashboardwebvert'
require_relative 'twb/util/twbdashsheetdatadotbuilder'
require_relative 'twb/util/csvrecordsatomizer'
require_relative 'twb/util/dotfilerenderer'
# require_relative 'twb/util/htmllistcollapsible'
require_relative 'twb/util/xraydashboards'
require_relative 'twb/util/graph'
require_relative 'twb/util/graphnode'
require_relative 'twb/util/graphedge'
require_relative 'twb/util/graphedges'
require_relative 'twb/util/gml'
require_relative 'twb/util/cypher'
require_relative 'twb/util/cypherpython'
require_relative 'twb/util/fielddomainloader'
require_relative 'twb/util/docprep'
require_relative 'twb/analysis/documentedfieldsmarkdownemitter'
require_relative 'twb/analysis/annotatedfieldscsvemitter'
require_relative 'twb/analysis/workbooksummaryanalyzer'
require_relative 'twb/analysis/calculatedfields/calculatedfieldsanalyzer'
require_relative 'twb/analysis/calculatedfields/dotanalyzer'
require_relative 'twb/analysis/calculatedfields/groupfieldsanalyzer'
require_relative 'twb/analysis/calculatedfields/markdownemitter'
require_relative 'twb/analysis/calculatedfields/csvemitter'
# require_relative 'twb/analysis/datasources/datasourcefieldscsvemitter'
require_relative 'twb/analysis/datasources/datasourcesenumerator.rb'
require_relative 'twb/analysis/datasources/datasourcefieldsanalyzer'
require_relative 'twb/analysis/datasources/datasourcefilesanalyzer'
# require_relative 'twb/analysis/datasources/datasourcetablefieldscsvemitter'
# require_relative 'twb/analysis/datasources/datasourcetablefieldsanalyzer'
require_relative 'twb/analysis/datasources/categoricalcolorcodinganalyzer'
require_relative 'twb/analysis/datasources/googlesheetdatasourcesanalyzer'
require_relative 'twb/analysis/datasources/parametersanalyzer'
require_relative 'twb/analysis/datasources/datasourceoriginsanalyzer'
require_relative 'twb/analysis/datasources/fieldsaliasesanalyzer'
require_relative 'twb/analysis/datasources/extractsanalyzer'
require_relative 'twb/analysis/sheets/worksheetsummarizer'
require_relative 'twb/analysis/sheets/worksheetdatastructurecsvemitter'
require_relative 'twb/analysis/sheets/sheetfiltersanalyzer'
require_relative 'twb/analysis/sheets/sheetfieldsanalyzer'
require_relative 'twb/analysis/sheets/dashboardsummarizer'
require_relative 'twb/analysis/sheets/dashsheetsanalyzer'
require_relative 'twb/analysis/sheets/sheetsintooltipanalyzer'

# Represents Tableau Workbooks, their contents, and classes that analyze and manipulate them.
#
module Twb
  VERSION = '5.2.7'
end
