#  calculatedfieldsanalyzer.rb - this Ruby script Copyright 2017 Christopher Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'twb'

module Twb
module Analysis

  class DocumentedFieldsMarkdownEmitter

    attr_reader :docFileName

    def initialize
      # puts ""
    end

    def processTwb twbName
      @twb = Twb::Workbook.new twbName
      @docFileName = '.ttdoc' + @twb.name + '.DocumentedFields.md'
      @docFile     = File.open(@docFileName,'w')
      @docFile.puts "## #{@twb.name}"
      dss = @twb.datasources
      @docFile.puts "#{dss.length} Data Source#{(dss.length>1) ? 's' : ''}"
      @docFile.puts " "
      dss.each do |ds|
        @docFile.puts "- #{ds.uiname}"
      end
      @docFile.puts " "
      dss.each do |ds|
        @docFile.puts "### #{ds.uiname}"
        columnFields = ds.columnFields  #.sort_by { |fldName,calc| fldName }
        columnFields.each do |field|
          commentLines = field.comment 
          calculation  = field.calcField
          # puts "\n#{field.uiname}"
          # puts "Comment? #{commentLines}"
          # puts "Calc   ? #{calculation}"
          @docFile.puts "\n##### #{field.uiname} "
          unless commentLines.nil?
            commentLines.each do |line|
              @docFile.puts "###### #{line}"
            end
          end
          unless calculation.nil?
            @docFile.puts "```"
              @docFile.puts calculation.formulaResolved
              @docFile.puts "\n -- Fields  --" unless calculation.calcFields.empty?
              refFields = SortedSet.new
              calculation.calcFields.each do |cf|
                fds =  if cf.dataSourceRef == :remote then "<<#{cf.dataSource}>>" else '' end
                refFields.add "#{cf.uiName} \t #{fds}"
              end
              refFields.each do |rf|
                @docFile.puts "    #{rf}"
              end
              @docFile.puts "```"
          end
        end
      end
    end

  end # class MarkdownEmitter

end   # module Analysis
end   # module Twb