#  Copyright (C) 2014, 2015, 2016  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'nokogiri'

module Twb

  class Connection

    include TabTool

    def self.attributeNames
        @@attributeNames ||= [
                                'authentication',
                                'authentication-type',
                                'auto-extract',
                                'channel',
                                'character-set',
                                'class',
                                'cleaning',
                                'compat',
                                'compressed-responses',
                                'compressed-responses-bulk',
                                'compressed-responses-rest',
                                'compressed-responses-soap',
                                'connection-type',
                                'dataRefreshTime',
                                'dbname',
                                'directory',
                                'disable-unicode',
                                'driver',
                                'enum-with-permissions',
                                'expected-driver-version',
                                'filename',
                                'force-character-set',
                                'force-header',
                                'force-separator',
                                'header',
                                'imex',
                                'interpretationMode',
                                'maxfieldlength',
                                'mdwpath',
                                'odbc-connect-string-extras',
                                'odbc-native-protocol',
                                'one-time-sql',
                                'pagesize',
                                'password',
                                'port',
                                'prefer-ind-semantics',
                                'query-band-spec',
                                'REDIRECT_URI',
                                'salesforce-api-version',
                                'schema',
                                'SCOPE',
                                'separator',
                                'server',
                                'server-oauth',
                                'service',
                                'sf-total-requestor-buffer-size-in-mb',
                                'show',
                                'tableau-ri',
                                'tablename',
                                'temporary',
                                'update-time',
                                'updated-database',
                                'use-nonemptycrossjoin',
                                'userLanguage',
                                'username',
                                'validate',
                                'workgroup-auth-mode'
                             ]
    end

    attr_reader :node, :xmlType, :attributes

    # node: XML element
    def initialize node
        @node    = node
        @xmlType = node.type
        @path    = node.path.gsub(/\[[0-9]+\]/,'')  
        @pathNum = /(\d+)/.match(@path)
        @name    = nil
    end

    def processConnection path
        conns = @node.xpath(path)
        conns.each do |connNode|
            connClass = @dsclass
            cpath     = conn.path
            connPath  = cpath.
            connPNum  = 
            # puts cpath, connPath
            # puts "CPATH: #{cpath}"
            conn.attributes.each do |name,value|
                # puts  "\n\t\t - %-15s -> %-s" % [name, value]
                $csvFile << [ $recCount += 1,
                              $twbName,  $dir,     $build,    $version,
                              $dsName,   $dstype,  $dsuiname, connClass, 
                              connPath,  connPNum,
                              name,      value.value
                            ]
            end
        end
    end

    def attributes
        @attributes ||= loadAttributes
    end

    private

    def loadAttributes
        @attributes = {}
        nodeAttrs = @node.attributes
        @@attributeNames.each do |a|
            @attributes[a] = nodeAttrs[a]
        end
        return @attributes
    end

  end # class

end # module Twb