#  Copyright (C) 2014, 2015  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'nokogiri'
require 'set'

module Twb

  class DocDashboard

  @@types = Set.new( ['h', 'horiz', 'horizontal',
                      'v', 'vert',  'vertical'   ] )

  attr_reader :title, :dashnode, :winnode, :type #, :panels, :autosize, :size
  
  def title=(title)
    @title = title
    @dashnode['name'] = title
    @winnode['name']  = title
  end

  def size=(size)
    @size = size
  end

  def initialize type
    dashboard = if @@types.include?(type)
                then if type[0] == 'v'
                     then DocDashboardVert.new
                     else DocDashboardHoriz.new
                     end
                else nil
                end
    return dashboard
  end
  
  def to_s
    return @title + ' :: ' + @type
  end

  end

  class DocDashboardWebHoriz < DocDashboard
    def initialize
      @type = 'horizontal'
    end
  end

end
