#  Copyright (C) 2014, 2015  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'nokogiri'

module Twb

  class DocDashboardImageVert < DocDashboard

    attr_reader :image 

@@dashdoc = <<-ONEIMAGEDASH
      <dashdoc>
        <dashboard name='Dashboard Automatic Vert with Image'>
          <style>
          </style>
          <zones>
            <zone h='100000' w='100000'
                  x='0'      y='0'
                  type='layout-flow'
                  param='vert' 
                  id='7' 
                  >
              <zone h='100000' w='100000'
                    x='0'      y='0'
                    type='title'
                    id='6' 
                    >
              </zone>
              <zone h='93157' w='100000'
                    x='0'     y='6221'
                    type='bitmap' 
                    is-centered='0'
                    is-scaled='1'
                    param='{fully qualified image file name here}' 
                    id='8'
                    >
              </zone>
            </zone>
          </zones>
        </dashboard>
        <window auto-hidden='0' class='dashboard' maximized='1' name='Dashboard Automatic with Image'>
          <active id='8' />
          <zones>
            <zone is-centered='0' is-scaled='1' name='' type='bitmap' />
          </zones>
        </window>
      </dashdoc>
ONEIMAGEDASH
    
    def initialize
      @oneImageDash = Nokogiri::XML::Document.parse @@dashdoc 
      # notes:
      #  - adding a size element to the <dashboard element will change it from automatic, e.g.
      #
      #    <dashboard name='One Column Web Page Laptop (800w 600h)'>
      #    <style>
      #    </style>
      #    <size maxheight='600' maxwidth='800' minheight='600' minwidth='800' />
      #
      #  - the 'name' sttributes for the window and dashboard must match
      @type = 'columnar Image'
      @dashnode = @oneImageDash.at_xpath('//dashboard')
      @winnode  = @oneImageDash.at_xpath('//window')
    end
        
    def title=(title)
      @title = title
      @dashnode['name'] = title
      @winnode['name']  = title
    end

    def image=(imageFile)
        @image = imageFile
        dashImageZone          = @dashnode.at_xpath('.//zone[@type="bitmap"]')
        dashImageZone['param'] = imageFile
    end
    
  end # class

end   # module 