#  Copyright (C) 2014, 2017  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

module Twb

  class Graphnode

    # @name - the visible name
    # @id   - the technical identifier, used to distinquish the node from similarly named nodes
    # @type - useful for categorizing the node
    attr_reader   :name, :id, :type
    attr_accessor :properties


    def initialize (name:, id:, type:, properties: {})
      @name        = name
      @id          = id
      @type        = type
      @properties  = properties
    end

    def dotLabel
      # "JIRA 1::JIRA 1.csv" [label="JIRA 1.csv"]
      "\"%s\" [label=\"%s\"]" % [id, name] 
    end

    def eql? other
      @name == other.name && @id == other.id && @type == other.type  && @properties == other.properties
    end

    def hash
      [@name, @id, @type, @properties].hash
    end

    def to_s
      "name:'%s'  id:'%s'  t:'%s'  p:'%s'" % [@name, @id, @type, @properties.to_s]
    end

  end

end
