#  Copyright (C) 2018  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'nokogiri'

module Twb
# module Data

  class GroupField

    include TabTool

    attr_reader :node
    attr_reader :name, :uiname, :caption

    def initialize node
      @node        = node
      @caption     = @node['caption']
      @name        = @node['name'].gsub(/^\[|\]$/,'')
      @uiname      = @caption.nil? ? @name : @caption
    end

    def id
        @id ||= @id = @name.hash
    end

    def properties
      @properties ||= loadProperties
    end

    def loadProperties
      @properties= {}
      @node.attributes.each do |name,attr|
        @properties[name] = attr.value
      end
      @properties[:uiname] = @name
      return @properties
    end

  end # class GroupField

# end # module Data
end # module Twb
