require 'nokogiri'
require 'csv'
require 'twb'

def init
  system 'cls'
  $pFile = File.open('identifyFields.txt','w')

  sqiCSV = 'TWBFieldsByType.csv'
  $fieldsCSV = CSV.open(sqiCSV, 'w')
  $fieldsCSV    << [
                    'TWB', 
                    'Data Connection - UI', 
                    'Field Name', 
                    'Field Type', 
                   ]
  $path    = if ARGV.empty? then '**/*.twb' else ARGV[0] end
  emit " "
  emit " Identifying fields in Tableau Workbook Data Connections (TWDCs).\n "
  emit " Looking for Workbooks matching: '#{$path}'  - from: #{ARGV[0]}\n\n "
end

def method_name
    datasources     = {}
    dataSourcesNode  = doc.at_xpath('//workbook/datasources')
    dataSourcesNodes = doc.xpath('//workbook/datasources/datasource').to_a
    puts "  dsn: #{dataSourcesNodes}"
    datasourceNodes.each do |node|
        datasource = Twb::DataSource.new(node)
        datasources[datasource.name] = datasource
    end
end
  
$localEmit = true
def emit stuff
    $pFile.puts stuff
           puts stuff if $localEmit
end

$paths = { 
          'Relation Column' => { 'fieldXPath' => './connection/relation/columns/column',
                                 'nameXPath'  => '@name' 
                               },
          'Metadata Record' => { 'fieldXPath' => './connection/metadata-records/metadata-record[@class="column"]',
                                 'nameXPath'  => './remote-name'
                               },
          'Columns'         => { 'fieldXPath' => './column',
                                 'nameXPath'  => '@name' 
                               },
         }

def proc file
  emit "\n == #{file}"
end

def process file
  emit "\n == #{file}"
  doc = Nokogiri::XML(open(file))
  dataSourcesNodes = doc.xpath('//workbook/datasources/datasource')
  dataSourcesNodes.each do |ds|
    emit "\n   dc: #{ds.attribute('caption')}"
    emit   "   dn: #{ds.attribute('name')}\n   ---"
    typeCounts = {}
    $paths.each do |type, path|
      nodes = ds.xpath(path).to_a
#      emit "     : %3i  %-17s  %-s" % [nodes.size, type, path]
      typeCnt = nodes.size
      nodes.each do |n|
#        $fieldsCSV << [file,ds.attribute('name'),n.attribute('name'),type]
      end
      if type == 'Columns' then 
        calcCnt = 0
        nodes.each do |n|
          calc = n.xpath('./calculation')
#          emit "    c:   #{calc.size} "
          calcCnt += calc.size
        end
#        emit '   ---'
#        emit "   c#: %3i " % [calcCnt]
#        emit "  !c#: %3i " % [nodes.size - calcCnt]
        typeCounts['Columns']            = nodes.size 
        typeCounts['Columns - calc']     = calcCnt 
        typeCounts['Columns - not calc'] = nodes.size - calcCnt 
      else
        typeCounts[type] = typeCnt 
      end
    end
#    emit '   ---'
    typeCounts.each do |t,c|
      emit "   tc: %3i  %-s" % [c, t]
    end
  end
end

init

$paths.each do |path|
	emit "  p: #{path}"
end

Dir.glob($path) {|twb| process twb }

emit "\n\n== Done ==\n "