#  Copyright (C) 2014, 2015  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'nokogiri'

module Twb

  # Assumption: A field can only be either a MetadataField or a LocalField, not both in a given Workbook data connection.

  class LocalField < TabClass

    attr_reader :node, :type, :datatype, :name, :uiname, :hidden, :ordinal, :properties

    def initialize fieldNode
      @node        = fieldNode
      @type        = 'local'
      @datatype    = @node.attr('datatype')
      @name        = @node.attr('name')
      @uiname      = @name
      @ordinal     = @node.attr('ordinal')
      # @properties  = @node.attributes
      # @dbname      = @node.attr('name').gsub(/^\[/,'').gsub(/\]$/,'')
      # @datatype    = @node.attr('datatype')
      # @role        = @node.attr('role')
      # @type        = @node.attr('type')
      @hidden      = @node.attr('hidden')
      # @caption     = @node.attr('caption')
      # @aggregation = @node.attr('aggregation')
      # @calculation = getCalculation
      # @comments    = getComments
      # @uiname      = if @caption.nil? || @caption == '' then @dbname else @caption end
      # return self
    end

    def id
        @id ||= @id = @name.hash
    end

    def properties
      @properties ||= loadProperties
    end

    def loadProperties
      @properties= {}
      @node.attributes.each do |name,attr|
        @properties[name] = attr.value
      end
      @properties[:uiname] = @name
      return @properties
    end

  end # class LocalField

end # module twb
