#  Copyright (C) 2014, 2015, 2016  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'logger'

module Twb

    class TabClass

        attr_accessor :uuid, :type, :id, :properties, :ttlogfile, :ttlogfilename

        @@ttlogfilename = 'TableauTools.ttlog'
        @@ttdocdir      = './ttdoc'
        @localEmit      = false

        def initialize
            @ttlogfile    = 'TableauTools.ttlog'
            @logger       = Logger.new(@ttlogfile)
            @logger.level = Logger::DEBUG
        end

        def type
            @type ||= @type = self.class.to_s.split(/(?=[A-Z])/).join(' ')
        end

        def uuid
            @uuid ||= @uuid = SecureRandom.uuid
        end

        def properties
            {}
        end

        def setDocFileName
            docFile @@ttlogfilename
        end

        def docFile name
          @ttdocdir.nil? ? name : "#{@@ttdocdir}/#{name}"
        end

        def emit(local=@localEmit, stuff)
            # puts "\nstuff.class #{stuff.class}  :: #{stuff}" if local
            if stuff.is_a? String then
              lines = stuff.split(/\n/)
              lines.each do |line|
                @logger.debug "#{@emitPrefix}#{line}"
                         puts "#{@emitPrefix}#{line}" if local
              end
            else
                @logger.debug "#{@emitPrefix}#{stuff}"
                         puts "#{@emitPrefix}#{stuff}" if local
            end
        end

    end

end

