#  Copyright (C) 2012, 2015  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

module Twb
module Util

  class DotFileRenderer
    @@gvDotLocation = 'C:\\tech\\graphviz\\Graphviz2.38\\bin\\dot.exe'
    @@renderTypes   = [:pdf, :png, :svg]

    def initialize
      @gvDotLocation = @@gvDotLocation
    end

    def gvDotLocation=(location)
      @gvDotLocation = location
    end

    def renderAll(dotFile)
      renderedFiles = []
      @@renderTypes.each do |type|
        renderedFiles << render(dotFile,type)
      end
      return renderedFiles
    end

    def render(dotFile, type)
      if @@renderTypes.include?(type)
        typeParam         = '-T' + type.to_s
        renderedFile      = dotFile.sub(/.dot$/,'') + '.' + type.to_s
        renderedFileParam = '-o' + renderedFile
        #puts "\t <render cmd> system #{@gvDotLocation}, #{typeParam}, #{renderedFileParam}, #{dotFile} "
        system @gvDotLocation, typeParam, renderedFileParam, dotFile
      end
      return renderedFile
    end
  end

end  # module Util
end  # module Twb
