#  Copyright (C) 2018  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

module Twb
module Util

require 'creek'
require 'csv'

  class FieldDomainLoader
    include TabTool

    @@xmlLocation = './ttdoc'

    attr_reader   :domains
    attr_accessor :xmllocation, :workboook, :datasource, :csvOption

    def initialize
      init
      reset
    end

    def reset
      @workbok     = nil
      @xmllocation = @@xmlLocation
      @csvOption   = 'w'
      initCSV @csvOption
    end

    def initCSV opt
      @csvFile     = CSV.open(@xmllocation + '/FieldDomains.csv', opt )
      if 'w'.eql? opt
        @csvFile << ['Workbook', 'Data Source', 'Field', 'Value']
      end
    end

    def load
      path = @xmllocation + '/*.xlsx'
      Dir.glob(path) do |fileName|
      end
    end

    def loadWorkbook twb
      @workbook = twb.name
      dsFieldDomains = {}
      dss = twb.datasources
      dsFieldDomains = {}
      dss.each do |ds|
        fieldDomains = loadDataSource ds
        dsFieldDomains[ds.uiname] = fieldDomains
      end
      return dsFieldDomains
    end

    def loadDataSource ds
      @datasource = ds.uiname
      fieldDomains = loadxlsx(@xmllocation + '/' + @datasource + '.xlsx')
    end

    def loadxlsx fileName
        fieldDomains = {}
        # TODO - fix this - when  Creek::Book is in place, the twb gem cannot be loaded in Ruby on Rails, as of Jan 26, 2019 
        #      - commenting out to sidestep problem giving up functionality for expedience in gtting online
        # if File.file?(fileName)
        #   xlsx = Creek::Book.new fileName
        #   sheets = xlsx.sheets
        #   sheets.each do |sheet|
        #       rows = sheet.rows.to_a
        #       if rows.count > 1
        #           fieldValues = parseRows(rows)
        #           unless fieldValues.empty? ||  fieldValues.values.first.empty?
        #               fieldDomains[fieldValues.keys.first] = fieldValues.values.first
        #           end
        #       end
        #   end
        # else
        #   alert  "#### ALERT #### Twb:'#{@workbook}' DS: '#{@datasource}' DomRef: #{fileName}' file does not exist."
        # end
        # return fieldDomains
    end

    def parseRows rows
        fieldValues = {}
        unless rows.empty?
            firstRow  = rows[0].to_a[0]
            fieldName = firstRow[1].to_s
            fieldValues[fieldName] = SortedSet.new
            values = rows[1..-1]
            values.each do |row|
                value = row.to_a[0][1].to_s
                fieldValues[fieldName] << value
            end
        end
        return fieldValues
    end

  end # class FieldDomainLoader

end  # module Util
end  # module Twb
