#  Copyright (C) 2014, 2017  Chris Gerrard
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

module Twb
module Util

require 'net/ftp'

  class FTPPublisher

    attr_reader :fileName, :fileURL

    def initialize
      @ftp      = Net::FTP.new('gerrard.net')
      @ftp.login("tableautools", 'TableauT00ls!')
    end

    def publish fileName
      @fileName = fileName
      @ftp.passive = true
      @ftp.puttextfile(fileName, fileName)
      @fileURL = "http://gerrard.net/tableautools/#{fileName}"
    end

    def list
      @ftp.list()
    end

    def close
      @ftp.close unless @ftp.nil?
    end

  end

end  # module Util
end  # module Twb
